#include "resolver.hh"
#include <assert.h>
/*
 Originally Written by John MacPherson <jrm21@cs.waikato.ac.nz>

*/

// grrr... stupid intel little endian!
#define dottedquad(a,b,c,d) (a) + (b << 8) + (c << 16) + (d << 24);

int main(void) {

	Resolver r(false);
	in_addr i;
	in_addr p;
        char *t = NULL;

	/* Localhost should work everywhere */
	r.get_ip("localhost", &i);
	p.s_addr = dottedquad(127,0,0,1);
	assert(p.s_addr==i.s_addr);
	
	i.s_addr = dottedquad(127,0,0,1);
	t = r.get_name(i);
	if (t) {
		if (strcasecmp(t, "localhost")!=0) {
			fprintf(stderr, "FAILED: 127.0.0.1 resolves to %s"
				" please check your resolver!\n", t);
		}
	} else {
		fprintf(stderr, "FAILED: Unable to resolve 127.0.0.1\n");
	}
	
	/* Use Root Servers because they are unlikey to change IP */
	i.s_addr = dottedquad(128,9,0,107);
	t = r.get_name(i);
	if (t) {
		if (strcasecmp(t, "b.root-servers.net")!=0) {
			fprintf(stderr, "FAILED: 128.9.0.107 resolves to %s"
				" expected b.root-servers.net please check "
				"your resolver!\n", t);
		}
	} else {
		fprintf(stderr, "FAILED: Unable to resolve 128.9.0.107\n");
	}

	i.s_addr = dottedquad(192,203,230,10);
	t = r.get_name(i);
	if (t) {
		if (strcasecmp(t, "e.root-servers.net")!=0) {
			fprintf(stderr, "FAILED: 192.203.230.10 resolves to %s"
				" expected e.root-servers.net please check "
				"your resolver!\n", t);
		}
	} else {
		fprintf(stderr, "FAILED: Unable to resolve 192.203.230.10\n");
	}

	r.get_ip("c.root-servers.net", &i);
	p.s_addr = dottedquad(192,33,4,12);
	if (p.s_addr!=i.s_addr) {
		fprintf(stderr, "FAILED: could not resolve c.root-servers.net to 192.33.4.12\n");
	}

	fflush(stdout);
	fflush(stderr);
	return (0);
}
